#ifndef MONSTERS_H
#define MONSTERS_H

#include <QString>
#include <QImage>
#include <vector>
#include "../common/sources/system/cmaths.h"

class CMonsters
{
public:
    enum EMonsterPos
    {
        eMonsterPosNone,    // empty monster
        eMonsterPosNorthWest,
        eMonsterPosNorthEast,
        eMonsterPosSouthWest,
        eMonsterPosSouthEast,
        eMonsterPosCenter
    };

    enum EMonsterDir
    {
        eMonsterDirUp,
        eMonsterDirDown,
        eMonsterDirLeft,
        eMonsterDirRight
    };

    struct SMonsterData
    {
        QString frontImage;
        QString sideImage;
        QString backImage;
        QString attackImage;
    };

    struct SMonster
    {
        EMonsterPos pos;
        EMonsterDir dir;
        int life;
    };

    struct SMonsterGroup
    {
        SMonster    monsters[4];
        EMonsterDir dir;
    };

    CMonsters();
    void    readMonstersDB();
    void    init();
    void    draw(QImage* image, CVec2 mapPos, CVec2 tablePos);

private:
    CVec2   getMonsterPos(float x, float y);

    std::vector<SMonsterData>   monstersDatas;
    std::vector<SMonsterGroup>  monsterGroups;
};

extern CMonsters    monsters;

#endif // MONSTERS_H
